#!/usr/local/bin/perl -w
#
#--------------------------------------------------------------------
# CERN, European Laboratory for Particle Physics
#
# User Documentation Templates
#
# Utility to batch replace a string in a text file
#--------------------------------------------------------------------
# 98/01/23, Mario.Ruggier@cern.ch 
#--------------------------------------------------------------------
#
# Synopsis: Globally replace a string with another, 
#           in all specified files.
#
#--------------------------------------------------------------------

foreach $x (0,1,2)  { 
    if ( length($ARGV[$x]) == 0 ) { &usage(); }
}

$mStr=$ARGV[0];
$rStr=$ARGV[1];

print "Replacing all occurances of: $mStr \n";
print "With: $rStr \n";

shift(@ARGV);
shift(@ARGV);

foreach $IFILE (@ARGV) {

	open(I,$IFILE) || die "Can't open $IFILE:$!\n";

	$OFILE = $IFILE . ".tmp"; 
	open(O,"> " . $OFILE) || die "Can't open $OFILE:$!\n";

	while (<I>) {
		s/$mStr/$rStr/g;
		print O $_;
	}
	close(I);
	close(O);
	rename($OFILE,$IFILE);
}

##################################################################

sub usage {
    die <<"EndUsage";

$0:
Globally replace a string with another, in all specified files.
NOTE: no quotes allowed inside the command line string parameters.

USAGE:
$0 <match string> <replace with string> <file [<file> [...]]>

EXAMPLE:
$0 "<BODY>" "<BODY BGCOLOR=#F0F0E8>" *.html

EndUsage
}

